#ifndef __AHOGHILL_THUMBNAILER_H__
#define __AHOGHILL_THUMBNAILER_H__

#include <glib-object.h>


G_BEGIN_DECLS

#define AHOGHILL_TYPE_THUMBNAILER                                       \
   (ahoghill_thumbnailer_get_type())
#define AHOGHILL_THUMBNAILER(obj)                                       \
   (G_TYPE_CHECK_INSTANCE_CAST ((obj),                                  \
                                AHOGHILL_TYPE_THUMBNAILER,              \
                                AhoghillThumbnailer))
#define AHOGHILL_THUMBNAILER_CLASS(klass)                               \
   (G_TYPE_CHECK_CLASS_CAST ((klass),                                   \
                             AHOGHILL_TYPE_THUMBNAILER,                 \
                             AhoghillThumbnailerClass))
#define IS_AHOGHILL_THUMBNAILER(obj)                                    \
   (G_TYPE_CHECK_INSTANCE_TYPE ((obj),                                  \
                                AHOGHILL_TYPE_THUMBNAILER))
#define IS_AHOGHILL_THUMBNAILER_CLASS(klass)                            \
   (G_TYPE_CHECK_CLASS_TYPE ((klass),                                   \
                             AHOGHILL_TYPE_THUMBNAILER))
#define AHOGHILL_THUMBNAILER_GET_CLASS(obj)                             \
   (G_TYPE_INSTANCE_GET_CLASS ((obj),                                   \
                               AHOGHILL_TYPE_THUMBNAILER,               \
                               AhoghillThumbnailerClass))

typedef struct _AhoghillThumbnailerPrivate AhoghillThumbnailerPrivate;
typedef struct _AhoghillThumbnailer      AhoghillThumbnailer;
typedef struct _AhoghillThumbnailerClass AhoghillThumbnailerClass;

typedef void (*AhoghillThumbnailerCallback) (AhoghillThumbnailer *thumbnailer,
                                             const char          *uri,
                                             int                  code,
                                             const char          *error,
                                             gpointer             data);

struct _AhoghillThumbnailer
{
    GObject parent;

    AhoghillThumbnailerPrivate *priv;
};

struct _AhoghillThumbnailerClass
{
    GObjectClass parent_class;
};

GType ahoghill_thumbnailer_get_type (void) G_GNUC_CONST;

void
ahoghill_thumbnailer_request_thumbnail (AhoghillThumbnailer         *thumbnailer,
                                        const char                  *uri,
                                        const char                  *mimetype,
                                        AhoghillThumbnailerCallback  callback,
                                        gpointer                     userdata);
G_END_DECLS

#endif /* __AHOGHILL_THUMBNAILER_H__ */
