#ifndef __AHOGHILL_FIXED_H__
#define __AHOGHILL_FIXED_H__

#include <mx/mx.h>


G_BEGIN_DECLS

#define AHOGHILL_TYPE_FIXED                     \
    (ahoghill_fixed_get_type())
#define AHOGHILL_FIXED(obj)                                             \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj),                                 \
                                 AHOGHILL_TYPE_FIXED,                   \
                                 AhoghillFixed))
#define AHOGHILL_FIXED_CLASS(klass)                                     \
    (G_TYPE_CHECK_CLASS_CAST ((klass),                                  \
                              AHOGHILL_TYPE_FIXED,                      \
                              AhoghillFixedClass))
#define IS_AHOGHILL_FIXED(obj)                                          \
    (G_TYPE_CHECK_INSTANCE_TYPE ((obj),                                 \
                                 AHOGHILL_TYPE_FIXED))
#define IS_AHOGHILL_FIXED_CLASS(klass)                                  \
    (G_TYPE_CHECK_CLASS_TYPE ((klass),                                  \
                              AHOGHILL_TYPE_FIXED))
#define AHOGHILL_FIXED_GET_CLASS(obj)                                   \
    (G_TYPE_INSTANCE_GET_CLASS ((obj),                                  \
                                AHOGHILL_TYPE_FIXED,                    \
                                AhoghillFixedClass))

typedef struct _AhoghillFixedPrivate AhoghillFixedPrivate;
typedef struct _AhoghillFixed      AhoghillFixed;
typedef struct _AhoghillFixedClass AhoghillFixedClass;

struct _AhoghillFixed
{
    MxWidget parent;

    AhoghillFixedPrivate *priv;
};

struct _AhoghillFixedClass
{
    MxWidgetClass parent_class;
};

GType ahoghill_fixed_get_type (void) G_GNUC_CONST;
void ahoghill_fixed_add_actor (AhoghillFixed *fixed,
                               ClutterActor  *actor);

G_END_DECLS

#endif /* __AHOGHILL_FIXED_H__ */
